/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JPanel.java to edit this template
 */
package PointOfSell;

import java.awt.GridLayout;
import java.util.ArrayList;

/**
 *
 * @author focus
 */
public class DrinksListPanel extends javax.swing.JPanel implements OnBuyProductListener {

    private ArrayList<OnBuyProductListener> subscriberList = new ArrayList<>();
    private final ArrayList<Product> productList;
    private POSPanel posPanel;

    /**
     * Creates new form DLP
     */
    public DrinksListPanel() {
        initComponents();
        productList = Product.getMockProductList();

        for (Product product : productList) {
            ProductPanel panel = new ProductPanel(product);
            pnlProduct.add(panel);
            panel.addOnBuyListener(this);
        }

        int num = pnlProduct.getComponentCount();
        int col = 3;
        pnlProduct.setLayout(new GridLayout(num / col + (num % col > 0 ? 1 : 0), col));

    }

    public void addOnBuyListener(OnBuyProductListener subscriber) {
        subscriberList.add(subscriber);
    }

    public void setProductPanel(ProductPanel pnlProduct) {
        this.pnlProduct = pnlProduct;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        pnlProduct = new javax.swing.JPanel();

        javax.swing.GroupLayout pnlProductLayout = new javax.swing.GroupLayout(pnlProduct);
        pnlProduct.setLayout(pnlProductLayout);
        pnlProductLayout.setHorizontalGroup(
            pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 566, Short.MAX_VALUE)
        );
        pnlProductLayout.setVerticalGroup(
            pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 445, Short.MAX_VALUE)
        );

        jScrollPane1.setViewportView(pnlProduct);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 568, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 447, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel pnlProduct;
    // End of variables declaration//GEN-END:variables

    @Override
    public void buy(Product product, int amount) {
        for (OnBuyProductListener p : subscriberList) { //แบบนี้ดีกว่า เนื่องจากใครจะ add ก็ได้
            p.buy(product, amount);
        }
    }

}
